!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! 2002.04.19 ORBanner	[Z, GLULX]
! Extends the standard library's banner routine, adding a userdefined value to append 
! to the bottom of the output and ORLib versioning too.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!--------------------------------------------------------------------------------------
! Created by Jim Fisher
! AutoDep:	none
!--------------------------------------------------------------------------------------
! This is just a simple extension to the standard library's banner routine.  It 
! identifies the version of the ORLibrary that was compiled in and exposes the
! global variable ORBannerText which can be defined in the program to add custom text
! to the banner.
!--------------------------------------------------------------------------------------
! To register this module with your library, add the line:
!
!		#include "ORBanner";					!Constant USE_ORBanner; 
!	
!	to the library header file (OR_Library_Include).  To use in a game, add the line:
!
!		Constant USE_ORBanner; to the game file;
!
!	to the game file;
!--------------------------------------------------------------------------------------
! Revision History
! 2001.07.03	Initial Creation
! 2002.02.12	repackaged with new library entry template
! 2002.02.16	repackaged with new library entry template (again).
! 2002.04.03	modified faulty WORDSIZE definition.
! 2002.04.19	Added support for ORBannerText variable to be a routine.
!--------------------------------------------------------------------------------------
#ifdef USE_ORBanner;message "          Processing library extension ORBanner...";
!--------------------------------------------------------------------------------------
! D E P E N D A N C I E S   section   (for bringing in dependant modules)
!--- sample forced include---   #ifndef USE_<REPLACEWITHINCLUDENAME>; Constant USE_<REPLACEWITHINCLUDENAME>; message "          ****Forcing inclusion of <REPLACEWITHINCLUDENAME>****"; #include "<REPLACEWITHINCLUDENAME>"; #endif; 
!--- #ifndef TARGET_GLULX; default WORDSIZE 2; #ifnot;default WORDSIZE 4; #endif; !--for GLULX compatability
!--------------------------------------------------------------------------------------


!--------------------------------------------------------------------------------------
#ifdef REPLACEPOINT; #ifndef ORBanner_DONEREPLACE; constant ORBanner_DONEREPLACE; 
!--------------------------------------------------------------------------------------
! R E P L A C E   section (for code that preceeds the inclusion of PARSER)
!--------------------------------------------------------------------------------------
	replace banner;
	default ORLibVersion "undefined";
	default ORLibDateStamp "undefined";
!--------------------------------------------------------------------------------------
#endif;#endif;#ifdef MESSAGEPOINT; #ifndef ORBanner_DONEMESSAGE; constant ORBanner_DONEMESSAGE; 
!--------------------------------------------------------------------------------------
! M E S S A G E   section (for code that falls between PARSER and VERBLIB )
!--- Uncomment to check for OREnglish--- #ifndef OREnglish; message "ERROR!!!! ORBanner requires the OREnglish file.";#endif; 
!--------------------------------------------------------------------------------------

!--------------------------------------------------------------------------------------
#endif; #endif; #ifdef CODEPOINT; #ifndef ORBanner_DONECODE;constant ORBanner_DONECODE; 
!--------------------------------------------------------------------------------------
! C O D E   section (for code that falls between VERBLIB and GRAMMAR)
!--------------------------------------------------------------------------------------
	default ORBannerText 0;
	[ Banner i;
		if(Story ~= 0){
			set_strong();
			print (string) Story;
			set_normal();
		}
		if (Headline ~= 0)
			print (string) Headline;
		#ifndef TARGET_GLULX;
			print "Release ", (0-->1) & $03ff, " / Serial number ";
			for (i=18:i<24:i++) print (char) 0->i;
		#ifnot; ! TARGET_ZCODE;
			print "Release ";
			@aloads 52 0 i;
			print i;
			print " / Serial number ";
			for (i=0:i<6:i++) print (char) 54->i;
		#endif; 
			print " / Inform v"; inversion;
			print " Library ", (string) LibRelease, " ";
		#ifdef STRICT_MODE;
			print "S";
		#endif;
		#ifdef INFIX;
			print "X";
		#ifnot;
			#ifdef DEBUG;
				print "D";
			#endif;
		#endif;
		print "^ORLibrary release ",(string)ORLibVersion," (",(string)ORLibDateStamp,")^";
		if(ORBannerText~=0) {
			switch(metaclass(ORBannerText)){
				string: print (string) ORBannerText;
				routine: ORBannerText();
			}
			
		}
		new_line;
	];
!--------------------------------------------------------------------------------------
#endif; #endif; #ifdef GRAMMARPOINT; #ifndef ORBanner_DONEGRAMMAR; constant ORBanner_DONEGRAMMAR; #ifdef ORBanner_DONEGRAMMAR; #endif; !--just to supress warning
!--------------------------------------------------------------------------------------
! G R A M M A R   section (for code that follows the inclusion of GRAMMAR)
!--------------------------------------------------------------------------------------


!--------------------------------------------------------------------------------------
#endif; #endif; #endif;
